<template>
  <div>
    <gz-report-selector ref="reportSelector"></gz-report-selector>
    <div v-if="formState.ready">
      <gz-error :error-box-message="formState.errorBoxMessage"></gz-error>
      <v-form ref="form">
        <v-row dense>
          <v-col cols="12" sm="6" lg="4" xl="3">
            <v-text-field
              ref="name"
              v-model="obj.name"
              dense
              :readonly="formState.readOnly"
              :label="$ay.t('PartName')"
              :rules="[form().required(this, 'name')]"
              :error-messages="form().serverErrors(this, 'name')"
              data-cy="name"
              @input="fieldValueChanged('name')"
            ></v-text-field>
          </v-col>

          <v-col
            v-if="form().showMe(this, 'Description')"
            cols="12"
            sm="6"
            lg="4"
            xl="3"
          >
            <v-text-field
              ref="description"
              v-model="obj.description"
              dense
              :readonly="formState.readOnly"
              :label="$ay.t('PartDescription')"
              data-cy="description"
              :error-messages="form().serverErrors(this, 'description')"
              @input="fieldValueChanged('description')"
            ></v-text-field>
          </v-col>

          <v-col cols="12" sm="6" lg="4" xl="3">
            <gz-currency
              ref="rateYear"
              v-model="obj.cost"
              :readonly="formState.readOnly"
              :label="$ay.t('PartCost')"
              data-cy="rateYear"
              :rules="[
                form().decimalValid(this, 'cost'),
                form().required(this, 'cost')
              ]"
              :error-messages="form().serverErrors(this, 'cost')"
              @input="fieldValueChanged('cost')"
            ></gz-currency>
          </v-col>

          <v-col cols="12" sm="6" lg="4" xl="3">
            <gz-currency
              ref="rateYear"
              v-model="obj.retail"
              :readonly="formState.readOnly"
              :label="$ay.t('PartRetail')"
              data-cy="rateYear"
              :rules="[
                form().decimalValid(this, 'retail'),
                form().required(this, 'retail')
              ]"
              :error-messages="form().serverErrors(this, 'retail')"
              @input="fieldValueChanged('retail')"
            ></gz-currency>
          </v-col>

          <v-col
            v-if="form().showMe(this, 'UnitOfMeasure')"
            cols="12"
            sm="6"
            lg="4"
            xl="3"
          >
            <v-combobox
              ref="unitOfMeasure"
              v-model="obj.unitOfMeasure"
              dense
              :readonly="formState.readOnly"
              :label="$ay.t('UnitOfMeasure')"
              data-cy="unitOfMeasure"
              :error-messages="form().serverErrors(this, 'unitOfMeasure')"
              :items="selectLists.priorUnits"
              @input="fieldValueChanged('unitOfMeasure')"
              @update:search-input="vComboBoxWorkAroundForUnit"
            ></v-combobox>
          </v-col>

          <v-col
            v-if="form().showMe(this, 'UPC')"
            cols="12"
            sm="6"
            lg="4"
            xl="3"
          >
            <v-text-field
              ref="upc"
              v-model="obj.upc"
              dense
              :readonly="formState.readOnly"
              :label="$ay.t('PartUPC')"
              data-cy="upc"
              :error-messages="form().serverErrors(this, 'upc')"
              @input="fieldValueChanged('upc')"
            ></v-text-field>
          </v-col>

          <v-col
            v-if="form().showMe(this, 'ManufacturerID')"
            cols="12"
            sm="6"
            lg="4"
            xl="3"
          >
            <gz-pick-list
              ref="manufacturerId"
              v-model="obj.manufacturerId"
              :aya-type="ayaTypes().Vendor"
              show-edit-icon
              :readonly="formState.readOnly"
              :label="$ay.t('PartManufacturerID')"
              data-cy="manufacturerId"
              :error-messages="form().serverErrors(this, 'manufacturerId')"
              @input="fieldValueChanged('manufacturerId')"
            ></gz-pick-list>
          </v-col>

          <v-col
            v-if="form().showMe(this, 'ManufacturerNumber')"
            cols="12"
            sm="6"
            lg="4"
            xl="3"
          >
            <v-text-field
              ref="manufacturerNumber"
              v-model="obj.manufacturerNumber"
              dense
              :readonly="formState.readOnly"
              :label="$ay.t('PartManufacturerNumber')"
              data-cy="manufacturerNumber"
              :error-messages="form().serverErrors(this, 'manufacturerNumber')"
              @input="fieldValueChanged('manufacturerNumber')"
            ></v-text-field>
          </v-col>

          <v-col
            v-if="form().showMe(this, 'WholesalerID')"
            cols="12"
            sm="6"
            lg="4"
            xl="3"
          >
            <gz-pick-list
              ref="wholeSalerId"
              v-model="obj.wholeSalerId"
              :aya-type="ayaTypes().Vendor"
              show-edit-icon
              :readonly="formState.readOnly"
              :label="$ay.t('PartWholesalerID')"
              data-cy="wholeSalerId"
              :error-messages="form().serverErrors(this, 'wholeSalerId')"
              @input="fieldValueChanged('wholeSalerId')"
            ></gz-pick-list>
          </v-col>

          <v-col
            v-if="form().showMe(this, 'WholesalerNumber')"
            cols="12"
            sm="6"
            lg="4"
            xl="3"
          >
            <v-text-field
              ref="wholeSalerNumber"
              v-model="obj.wholeSalerNumber"
              dense
              :readonly="formState.readOnly"
              :label="$ay.t('PartWholesalerNumber')"
              data-cy="wholeSalerNumber"
              :error-messages="form().serverErrors(this, 'wholeSalerNumber')"
              @input="fieldValueChanged('wholeSalerNumber')"
            ></v-text-field>
          </v-col>

          <v-col
            v-if="form().showMe(this, 'AlternativeWholesalerID')"
            cols="12"
            sm="6"
            lg="4"
            xl="3"
          >
            <gz-pick-list
              ref="alternativeWholeSalerId"
              v-model="obj.alternativeWholeSalerId"
              :aya-type="ayaTypes().Vendor"
              show-edit-icon
              :readonly="formState.readOnly"
              :label="$ay.t('PartAlternativeWholesalerID')"
              data-cy="alternativeWholeSalerId"
              :error-messages="
                form().serverErrors(this, 'alternativeWholeSalerId')
              "
              @input="fieldValueChanged('alternativeWholeSalerId')"
            ></gz-pick-list>
          </v-col>

          <v-col
            v-if="form().showMe(this, 'AlternativeWholesalerNumber')"
            cols="12"
            sm="6"
            lg="4"
            xl="3"
          >
            <v-text-field
              ref="alternativeWholeSalerNumber"
              v-model="obj.alternativeWholeSalerNumber"
              dense
              :readonly="formState.readOnly"
              :label="$ay.t('PartAlternativeWholesalerNumber')"
              data-cy="alternativeWholeSalerNumber"
              :error-messages="
                form().serverErrors(this, 'alternativeWholeSalerNumber')
              "
              @input="fieldValueChanged('alternativeWholeSalerNumber')"
            ></v-text-field>
          </v-col>

          <!-- --------------------------------- -->
          <v-col cols="12" sm="6" lg="4" xl="3">
            <v-checkbox
              ref="active"
              v-model="obj.active"
              dense
              :readonly="formState.readOnly"
              :label="$ay.t('Active')"
              data-cy="active"
              :error-messages="form().serverErrors(this, 'active')"
              @change="fieldValueChanged('active')"
            ></v-checkbox>
          </v-col>

          <v-col v-if="form().showMe(this, 'Notes')" cols="12">
            <v-textarea
              ref="notes"
              v-model="obj.notes"
              dense
              :readonly="formState.readOnly"
              :label="$ay.t('PartNotes')"
              :error-messages="form().serverErrors(this, 'notes')"
              data-cy="notes"
              auto-grow
              @input="fieldValueChanged('notes')"
            ></v-textarea>
          </v-col>

          <v-col v-if="form().showMe(this, 'Tags')" cols="12">
            <gz-tag-picker
              ref="tags"
              v-model="obj.tags"
              :readonly="formState.readOnly"
              data-cy="tags"
              :error-messages="form().serverErrors(this, 'tags')"
              @input="fieldValueChanged('tags')"
            ></gz-tag-picker>
          </v-col>

          <v-col cols="12">
            <gz-custom-fields
              ref="customFields"
              v-model="obj.customFields"
              :form-key="formCustomTemplateKey"
              :readonly="formState.readOnly"
              :parent-v-m="this"
              data-cy="customFields"
              :error-messages="form().serverErrors(this, 'customFields')"
              @input="fieldValueChanged('customFields')"
            ></gz-custom-fields>
          </v-col>

          <v-col v-if="form().showMe(this, 'Wiki')" cols="12">
            <gz-wiki
              ref="wiki"
              v-model="obj.wiki"
              :aya-type="ayaType"
              :aya-id="obj.id"
              :readonly="formState.readOnly"
              @input="fieldValueChanged('wiki')"
            ></gz-wiki
          ></v-col>

          <v-col v-if="form().showMe(this, 'Attachments') && obj.id" cols="12">
            <gz-attachments
              :readonly="formState.readOnly"
              :aya-type="ayaType"
              :aya-id="obj.id"
            ></gz-attachments
          ></v-col>
        </v-row>
      </v-form>
    </div>
    <v-overlay :value="!formState.ready || formState.loading">
      <v-progress-circular indeterminate :size="64" />
    </v-overlay>
  </div>
</template>
<script>
const FORM_KEY = "inv-part-edit";
const API_BASE_URL = "part/";
const FORM_CUSTOM_TEMPLATE_KEY = "Part";
export default {
  data() {
    return {
      formCustomTemplateKey: FORM_CUSTOM_TEMPLATE_KEY,
      obj: {
        id: 0,
        concurrency: 0,
        name: null,
        active: true,
        notes: null,
        wiki: null,
        customFields: "{}",
        tags: [],
        description: null,
        manufacturerId: null,
        manufacturerNumber: null,
        wholeSalerId: null,
        wholeSalerNumber: null,
        alternativeWholeSalerId: null,
        alternativeWholeSalerNumber: null,
        cost: 0,
        retail: 0,
        unitOfMeasure: null,
        upc: null
      },
      formState: {
        ready: false,
        dirty: false,
        valid: true,
        readOnly: false,
        loading: true,
        errorBoxMessage: null,
        appError: null,
        serverError: {}
      },
      rights: window.$gz.role.defaultRightsObject(),
      ayaType: window.$gz.type.Part,
      selectLists: {
        priorUnits: []
      }
    };
  },
  watch: {
    formState: {
      handler: function(val) {
        if (this.formState.loading) {
          return;
        }
        if (val.dirty && val.valid && !val.readOnly) {
          window.$gz.eventBus.$emit("menu-enable-item", FORM_KEY + ":save");
        } else {
          window.$gz.eventBus.$emit("menu-disable-item", FORM_KEY + ":save");
        }
        if (!val.dirty && val.valid && !val.readOnly) {
          window.$gz.eventBus.$emit(
            "menu-enable-item",
            FORM_KEY + ":duplicate"
          );
          window.$gz.eventBus.$emit("menu-enable-item", FORM_KEY + ":new");
        } else {
          window.$gz.eventBus.$emit(
            "menu-disable-item",
            FORM_KEY + ":duplicate"
          );
          window.$gz.eventBus.$emit("menu-disable-item", FORM_KEY + ":new");
        }
      },
      deep: true
    }
  },
  async created() {
    const vm = this;

    try {
      await initForm(vm);
      vm.rights = window.$gz.role.getRights(window.$gz.type.Part);
      vm.formState.readOnly = !vm.rights.change;
      window.$gz.eventBus.$on("menu-click", clickHandler);
      let setDirty = false;
      //id 0 means create or duplicate to new
      if (vm.$route.params.recordid != 0) {
        //is there already an obj from a prior operation?
        if (this.$route.params.obj) {
          //yes, no need to fetch it
          this.obj = this.$route.params.obj;
        } else {
          await vm.getDataFromApi(vm.$route.params.recordid);
        }
      } else {
        //Might be a duplicate and contain another record
        if (this.$route.params.obj) {
          this.obj = this.$route.params.obj;
          this.obj.concurrency = undefined;
          this.obj.id = 0;
          this.obj.name = `${this.obj.name} - ${window.$gz.translation.get(
            "Copy"
          )}`;
          setDirty = true;
        }
      }
      window.$gz.form.setFormState({
        vm: vm,
        loading: false,
        dirty: setDirty,
        valid: true
      });
      generateMenu(vm);
    } catch (error) {
      window.$gz.errorHandler.handleFormError(error, vm);
    } finally {
      vm.formState.ready = true;
    }
  },
  async beforeRouteLeave(to, from, next) {
    if (!this.formState.dirty || JUST_DELETED) {
      next();
      return;
    }
    if ((await window.$gz.dialog.confirmLeaveUnsaved()) === true) {
      next();
    } else {
      next(false);
    }
  },
  beforeDestroy() {
    window.$gz.eventBus.$off("menu-click", clickHandler);
  },
  methods: {
    canSave: function() {
      return this.formState.valid && this.formState.dirty;
    },
    canDuplicate: function() {
      return this.formState.valid && !this.formState.dirty;
    },
    ayaTypes: function() {
      return window.$gz.type;
    },
    form() {
      return window.$gz.form;
    },
    vComboBoxWorkAroundForUnit(currentValue) {
      //shitty workaround due to bug https://github.com/vuetifyjs/vuetify/issues/4679#issuecomment-682456398
      //fires every time the control changes so check to see if actual change or not
      if (currentValue == this.obj.unitOfMeasure) {
        return;
      }

      this.obj.unitOfMeasure = currentValue;
      this.fieldValueChanged("unitOfMeasure");
    },
    fieldValueChanged(ref) {
      if (
        this.formState.ready &&
        !this.formState.loading &&
        !this.formState.readOnly
      ) {
        window.$gz.form.fieldValueChanged(this, ref);
      }
    },
    async getDataFromApi(recordId) {
      const vm = this;
      window.$gz.form.setFormState({
        vm: vm,
        loading: true
      });
      if (!recordId) {
        throw new Error(FORM_KEY + "::getDataFromApi -> Missing recordID!");
      }
      try {
        window.$gz.form.deleteAllErrorBoxErrors(vm);
        const res = await window.$gz.api.get(API_BASE_URL + recordId);
        if (res.error) {
          if (res.error.code == "2010") {
            window.$gz.form.handleObjectNotFound(vm);
          }
          vm.formState.serverError = res.error;
          window.$gz.form.setErrorBoxErrors(vm);
        } else {
          vm.obj = res.data;
          generateMenu(vm);
          window.$gz.form.setFormState({
            vm: vm,
            dirty: false,
            valid: true,
            loading: false
          });
        }
      } catch (error) {
        window.$gz.errorHandler.handleFormError(error, vm);
      } finally {
        window.$gz.form.setFormState({
          vm: vm,
          loading: false
        });
      }
    },
    async submit() {
      const vm = this;
      if (vm.canSave == false) {
        return;
      }

      try {
        window.$gz.form.setFormState({
          vm: vm,
          loading: true
        });
        window.$gz.form.deleteAllErrorBoxErrors(vm);
        const res = await window.$gz.api.upsert(API_BASE_URL, vm.obj);
        if (res.error) {
          vm.formState.serverError = res.error;
          window.$gz.form.setErrorBoxErrors(vm);
        } else {
          if (res.data.id) {
            //POST
            vm.obj = res.data;
            this.$router.push({
              name: "inv-part",
              params: {
                recordid: res.data.id,
                obj: res.data
              }
            });
          } else {
            //PUT
            vm.obj.concurrency = res.data.concurrency;
          }
          window.$gz.form.setFormState({
            vm: vm,
            dirty: false,
            valid: true
          });
        }
      } catch (ex) {
        window.$gz.errorHandler.handleFormError(ex, vm);
      } finally {
        window.$gz.form.setFormState({
          vm: vm,
          loading: false
        });
      }
    },
    async remove() {
      try {
        const dialogResult = await window.$gz.dialog.confirmDelete();
        if (dialogResult != true) {
          return;
        }
        window.$gz.form.setFormState({
          vm: this,
          loading: true
        });
        if (this.$route.params.recordid == 0) {
          JUST_DELETED = true;
          this.$router.go(-1);
        } else {
          window.$gz.form.deleteAllErrorBoxErrors(this);
          const res = await window.$gz.api.remove(
            API_BASE_URL + this.$route.params.recordid
          );
          if (res.error) {
            this.formState.serverError = res.error;
            window.$gz.form.setErrorBoxErrors(this);
          } else {
            JUST_DELETED = true;
            this.$router.go(-1);
          }
        }
      } catch (error) {
        window.$gz.errorHandler.handleFormError(error, this);
      } finally {
        window.$gz.form.setFormState({
          vm: this,
          loading: false
        });
      }
    },
    duplicate() {
      this.$router.push({
        name: "inv-part",
        params: {
          recordid: 0,
          obj: this.obj
        }
      });
    }
  }
};

/////////////////////////////
//
//
async function clickHandler(menuItem) {
  if (!menuItem) {
    return;
  }
  const m = window.$gz.menu.parseMenuItem(menuItem);
  if (m.owner == FORM_KEY && !m.disabled) {
    switch (m.key) {
      case "save":
        m.vm.submit();
        break;
      case "delete":
        m.vm.remove();
        break;
      case "new":
        m.vm.$router.push({
          name: "inv-part",
          params: { recordid: 0 }
        });
        break;
      case "duplicate":
        m.vm.duplicate();
        break;
      case "report":
        {
          const res = await m.vm.$refs.reportSelector.open(
            {
              AType: window.$gz.type.Part,
              selectedRowIds: [m.vm.obj.id]
            },
            m.id
          );
          if (res == null) {
            return;
          }
          window.$gz.form.setLastReportMenuItem(FORM_KEY, res, m.vm);
        }
        break;
      case "PartSerialNumbersAvailable":
        m.vm.$router.push({
          name: "inv-part-serials",
          params: { recordid: m.vm.obj.id }
        });
        break;
      case "PartStockingLevels":
        m.vm.$router.push({
          name: "inv-part-stock-levels",
          params: { recordid: m.vm.obj.id }
        });
        break;
      case "PartByWarehouseInventoryList":
        m.vm.$router.push({
          name: "inv-part-inventory",
          params: {
            filter: {
              PartName: m.vm.obj.name,
              objectId: m.vm.obj.id,
              ayatype: window.$gz.type.Part,
              viz: m.vm.obj.name + (m.vm.obj.name ? " " + m.vm.obj.name : ""),
              icon: "$ayiBoxes"
            }
          }
        });
        break;
      case "PartInventoryTransactionList":
        m.vm.$router.push({
          name: "inv-part-inventory-transactions",
          params: {
            filter: {
              PartName: m.vm.obj.name,
              objectId: m.vm.obj.id,
              ayatype: window.$gz.type.Part,
              viz: m.vm.obj.name + (m.vm.obj.name ? " " + m.vm.obj.name : ""),
              icon: "$ayiBoxes"
            }
          }
        });
        break;
      case "WorkOrderItemPartList":
        m.vm.$router.push({
          name: "svc-workorder-item-parts",
          params: {
            aType: m.vm.ayaType,
            objectId: m.vm.obj.id,
            name: m.vm.obj.name
          }
        });
        break;
      case "QuoteList":
        m.vm.$router.push({
          name: "svc-quote-item-parts",
          params: {
            aType: m.vm.ayaType,
            objectId: m.vm.obj.id,
            name: m.vm.obj.name
          }
        });
        break;
      case "PMList":
        m.vm.$router.push({
          name: "svc-pm-item-parts",
          params: {
            aType: m.vm.ayaType,
            objectId: m.vm.obj.id,
            name: m.vm.obj.name
          }
        });
        break;
      default:
        window.$gz.eventBus.$emit(
          "notify-warning",
          FORM_KEY + "::context click: [" + m.key + "]"
        );
    }
  }
}

//////////////////////
//
//
function generateMenu(vm) {
  const menuOptions = {
    isMain: false,
    readOnly: vm.formState.readOnly,
    icon: "$ayiBoxes",
    title: "Part",
    helpUrl: "inv-parts",
    formData: {
      ayaType: window.$gz.type.Part,
      recordId: vm.$route.params.recordid,
      formCustomTemplateKey: FORM_CUSTOM_TEMPLATE_KEY,
      recordName:
        vm.obj.name + (vm.obj.description ? " " + vm.obj.description : "")
    },
    menuItems: []
  };

  if (vm.rights.change) {
    menuOptions.menuItems.push({
      title: "Save",
      icon: "$ayiSave",
      surface: true,
      key: FORM_KEY + ":save",
      vm: vm
    });
  }

  menuOptions.menuItems.push({
    title: "Report",
    icon: "$ayiFileAlt",
    key: FORM_KEY + ":report",
    vm: vm
  });

  const lastReport = window.$gz.form.getLastReport(FORM_KEY);
  if (lastReport != null) {
    menuOptions.menuItems.push({
      title: lastReport.name,
      notrans: true,
      icon: "$ayiFileAlt",
      key: FORM_KEY + ":report:" + lastReport.id,
      vm: vm
    });
  }

  if (vm.rights.change) {
    menuOptions.menuItems.push({
      title: "New",
      icon: "$ayiPlus",
      key: FORM_KEY + ":new",
      vm: vm
    });
  }

  if (vm.rights.change && vm.$route.params.recordid != 0) {
    menuOptions.menuItems.push({
      title: "Duplicate",
      icon: "$ayiClone",
      key: FORM_KEY + ":duplicate",
      vm: vm
    });
  }

  if (vm.rights.delete && vm.$route.params.recordid != 0) {
    menuOptions.menuItems.push({
      title: "Delete",
      icon: "$ayiTrashAlt",
      surface: false,
      key: FORM_KEY + ":delete",
      vm: vm
    });
  }

  menuOptions.menuItems.push({ divider: true, inset: false });

  if (
    vm.obj.id != null &&
    vm.obj.id != 0 &&
    window.$gz.store.state.globalSettings.useInventory
  ) {
    menuOptions.menuItems.push({
      title: "PartByWarehouseInventoryList",
      icon: "$ayiPallet",
      key: FORM_KEY + ":PartByWarehouseInventoryList",
      vm: vm
    });

    menuOptions.menuItems.push({
      title: "PartInventoryTransactionList",
      icon: "$ayiPeopleCarry",
      key: FORM_KEY + ":PartInventoryTransactionList",
      vm: vm
    });

    menuOptions.menuItems.push({
      title: "PartStockingLevels",
      icon: null,
      key: FORM_KEY + ":PartStockingLevels",
      vm: vm
    });
  }

  if (vm.obj.id != null && vm.obj.id != 0) {
    menuOptions.menuItems.push({
      title: "PartSerialNumbersAvailable",
      icon: null,
      key: FORM_KEY + ":PartSerialNumbersAvailable",
      vm: vm
    });
  }

  menuOptions.menuItems.push({
    title: "WorkOrderList", //note: technically it opens teh woitemunitlist not workorders but it's confusing in the UI otherwise and this is how people would think about it
    icon: "$ayiTools",
    key: FORM_KEY + ":WorkOrderItemPartList",
    vm: vm
  });

  menuOptions.menuItems.push({
    title: "QuoteList",
    icon: "$ayiPencilAlt",
    key: FORM_KEY + ":QuoteList",
    vm: vm
  });

  menuOptions.menuItems.push({
    title: "PMList",
    icon: "$ayiBusinessTime",
    key: FORM_KEY + ":PMList",
    vm: vm
  });

  menuOptions.menuItems.push({ divider: true, inset: false });

  window.$gz.eventBus.$emit("menu-change", menuOptions);
}

let JUST_DELETED = false;

/////////////////////////////////
//
//
async function initForm(vm) {
  await populateSelectionLists(vm);
  await fetchTranslatedText();
  await window.$gz.formCustomTemplate.get(FORM_CUSTOM_TEMPLATE_KEY, vm);
}

//////////////////////
//
//
async function populateSelectionLists(vm) {
  const res = await window.$gz.api.get("part/prior-unit-of-measure-list");
  if (res.error) {
    vm.formState.serverError = res.error;
    window.$gz.form.setErrorBoxErrors(vm);
  } else {
    vm.selectLists.priorUnits = res.data;
  }
}

//////////////////////////////////////////////////////////
//
// Ensures UI translated text is available
//
async function fetchTranslatedText() {
  await window.$gz.translation.cacheTranslations([
    "Part",
    "PartByWarehouseInventoryList",
    "PartInventoryTransactionList",
    "PartSerialNumbersAvailable",
    "PartStockingLevels",
    "PartName",
    "PartNotes",
    "PartDescription",
    "PartCost",
    "PartRetail",
    "PartManufacturerID",
    "PartManufacturerNumber",
    "PartWholesalerID",
    "PartWholesalerNumber",
    "PartAlternativeWholesalerID",
    "PartAlternativeWholesalerNumber",
    "UnitOfMeasure",
    "PartUPC",
    "PartCustom1",
    "PartCustom2",
    "PartCustom3",
    "PartCustom4",
    "PartCustom5",
    "PartCustom6",
    "PartCustom7",
    "PartCustom8",
    "PartCustom9",
    "PartCustom10",
    "PartCustom11",
    "PartCustom12",
    "PartCustom13",
    "PartCustom14",
    "PartCustom15",
    "PartCustom16"
  ]);
}
</script>
